---
title: Create an AI memory violation result
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Static Analysis
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Create an AI memory violation result{% #create-an-ai-memory-violation-result %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                        |
| ----------------- | ------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/static-analysis/ai/memory |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/static-analysis/ai/memory |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/static-analysis/ai/memory      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/static-analysis/ai/memory      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/static-analysis/ai/memory  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/static-analysis/ai/memory |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/static-analysis/ai/memory     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/static-analysis/ai/memory |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/static-analysis/ai/memory |

### Overview

Add a new AI memory violation result for the authenticated organization.

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                           | Type   | Description                                                                                                                     |
| ------------ | ------------------------------- | ------ | ------------------------------------------------------------------------------------------------------------------------------- |
|              | data                            | object | Request data for creating an AI memory violation result.                                                                        |
| data         | attributes                      | object | Attributes for creating an AI memory violation result.                                                                          |
| attributes   | line [*required*]          | int64  | The line number where the violation was found.                                                                                  |
| attributes   | message [*required*]       | string | A message explaining the violation result.                                                                                      |
| attributes   | name [*required*]          | string | The file path where the violation was found.                                                                                    |
| attributes   | repository_id [*required*] | string | The repository identifier.                                                                                                      |
| attributes   | rule [*required*]          | string | The rule identifier in the format ruleset/rule.                                                                                 |
| attributes   | sha [*required*]           | string | The git commit SHA where the violation was found.                                                                               |
| attributes   | type [*required*]          | enum   | The type of AI memory violation result indicating whether it is a true positive or false positive. Allowed enum values: `TP,FP` |
| data         | id                              | string | The violation result identifier.                                                                                                |
| data         | type                            | enum   | AI memory violation result resource type. Allowed enum values: `ai_memory_violation_result`                                     |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "line": 10,
      "message": "This is a false positive because the input is sanitized.",
      "name": "src/main.py",
      "repository_id": "my-repo",
      "rule": "my-ai-ruleset/my-ai-rule",
      "sha": "abc123def456789012345678901234567890abcd",
      "type": "FP"
    },
    "id": "violation-abc",
    "type": "ai_memory_violation_result"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
Successfully created
{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="500" %}
Internal Server Error
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/static-analysis/ai/memory" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "line": 10,
      "message": "This is a false positive.",
      "name": "src/main.py",
      "repository_id": "my-repo",
      "rule": "my-ai-ruleset/my-ai-rule",
      "sha": "abc123def456789012345678901234567890abcd",
      "type": "FP"
    },
    "id": "violation-abc",
    "type": "ai_memory_violation_result"
  }
}
EOF 
                
##### 

```python
"""
Create an AI memory violation result returns "Successfully created" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.static_analysis_api import StaticAnalysisApi
from datadog_api_client.v2.model.ai_memory_violation_result_data_type import AiMemoryViolationResultDataType
from datadog_api_client.v2.model.ai_memory_violation_result_request import AiMemoryViolationResultRequest
from datadog_api_client.v2.model.ai_memory_violation_result_request_attributes import (
    AiMemoryViolationResultRequestAttributes,
)
from datadog_api_client.v2.model.ai_memory_violation_result_request_data import AiMemoryViolationResultRequestData
from datadog_api_client.v2.model.ai_memory_violation_type import AiMemoryViolationType

body = AiMemoryViolationResultRequest(
    data=AiMemoryViolationResultRequestData(
        attributes=AiMemoryViolationResultRequestAttributes(
            line=10,
            message="This is a false positive because the input is sanitized.",
            name="src/main.py",
            repository_id="my-repo",
            rule="my-ai-ruleset/my-ai-rule",
            sha="abc123def456789012345678901234567890abcd",
            type=AiMemoryViolationType.FP,
        ),
        id="violation-abc",
        type=AiMemoryViolationResultDataType.AI_MEMORY_VIOLATION_RESULT,
    ),
)

configuration = Configuration()
configuration.unstable_operations["create_ai_memory_violation_result"] = True
with ApiClient(configuration) as api_client:
    api_instance = StaticAnalysisApi(api_client)
    api_instance.create_ai_memory_violation_result(body=body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Create an AI memory violation result returns "Successfully created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.create_ai_memory_violation_result".to_sym] = true
end
api_instance = DatadogAPIClient::V2::StaticAnalysisAPI.new

body = DatadogAPIClient::V2::AiMemoryViolationResultRequest.new({
  data: DatadogAPIClient::V2::AiMemoryViolationResultRequestData.new({
    attributes: DatadogAPIClient::V2::AiMemoryViolationResultRequestAttributes.new({
      line: 10,
      message: "This is a false positive because the input is sanitized.",
      name: "src/main.py",
      repository_id: "my-repo",
      rule: "my-ai-ruleset/my-ai-rule",
      sha: "abc123def456789012345678901234567890abcd",
      type: DatadogAPIClient::V2::AiMemoryViolationType::FP,
    }),
    id: "violation-abc",
    type: DatadogAPIClient::V2::AiMemoryViolationResultDataType::AI_MEMORY_VIOLATION_RESULT,
  }),
})
p api_instance.create_ai_memory_violation_result(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// Create an AI memory violation result returns "Successfully created" response

package main

import (
	"context"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.AiMemoryViolationResultRequest{
		Data: &datadogV2.AiMemoryViolationResultRequestData{
			Attributes: &datadogV2.AiMemoryViolationResultRequestAttributes{
				Line:         10,
				Message:      "This is a false positive because the input is sanitized.",
				Name:         "src/main.py",
				RepositoryId: "my-repo",
				Rule:         "my-ai-ruleset/my-ai-rule",
				Sha:          "abc123def456789012345678901234567890abcd",
				Type:         datadogV2.AIMEMORYVIOLATIONTYPE_FP,
			},
			Id:   datadog.PtrString("violation-abc"),
			Type: datadogV2.AIMEMORYVIOLATIONRESULTDATATYPE_AI_MEMORY_VIOLATION_RESULT.Ptr(),
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateAiMemoryViolationResult", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewStaticAnalysisApi(apiClient)
	r, err := api.CreateAiMemoryViolationResult(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `StaticAnalysisApi.CreateAiMemoryViolationResult`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Create an AI memory violation result returns "Successfully created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.StaticAnalysisApi;
import com.datadog.api.client.v2.model.AiMemoryViolationResultDataType;
import com.datadog.api.client.v2.model.AiMemoryViolationResultRequest;
import com.datadog.api.client.v2.model.AiMemoryViolationResultRequestAttributes;
import com.datadog.api.client.v2.model.AiMemoryViolationResultRequestData;
import com.datadog.api.client.v2.model.AiMemoryViolationType;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.createAiMemoryViolationResult", true);
    StaticAnalysisApi apiInstance = new StaticAnalysisApi(defaultClient);

    AiMemoryViolationResultRequest body =
        new AiMemoryViolationResultRequest()
            .data(
                new AiMemoryViolationResultRequestData()
                    .attributes(
                        new AiMemoryViolationResultRequestAttributes()
                            .line(10L)
                            .message("This is a false positive because the input is sanitized.")
                            .name("src/main.py")
                            .repositoryId("my-repo")
                            .rule("my-ai-ruleset/my-ai-rule")
                            .sha("abc123def456789012345678901234567890abcd")
                            .type(AiMemoryViolationType.FP))
                    .id("violation-abc")
                    .type(AiMemoryViolationResultDataType.AI_MEMORY_VIOLATION_RESULT));

    try {
      apiInstance.createAiMemoryViolationResult(body);
    } catch (ApiException e) {
      System.err.println("Exception when calling StaticAnalysisApi#createAiMemoryViolationResult");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// Create an AI memory violation result returns "Successfully created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_static_analysis::StaticAnalysisAPI;
use datadog_api_client::datadogV2::model::AiMemoryViolationResultDataType;
use datadog_api_client::datadogV2::model::AiMemoryViolationResultRequest;
use datadog_api_client::datadogV2::model::AiMemoryViolationResultRequestAttributes;
use datadog_api_client::datadogV2::model::AiMemoryViolationResultRequestData;
use datadog_api_client::datadogV2::model::AiMemoryViolationType;

#[tokio::main]
async fn main() {
    let body = AiMemoryViolationResultRequest::new().data(
        AiMemoryViolationResultRequestData::new()
            .attributes(AiMemoryViolationResultRequestAttributes::new(
                10,
                "This is a false positive because the input is sanitized.".to_string(),
                "src/main.py".to_string(),
                "my-repo".to_string(),
                "my-ai-ruleset/my-ai-rule".to_string(),
                "abc123def456789012345678901234567890abcd".to_string(),
                AiMemoryViolationType::FP,
            ))
            .id("violation-abc".to_string())
            .type_(AiMemoryViolationResultDataType::AI_MEMORY_VIOLATION_RESULT),
    );
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.CreateAiMemoryViolationResult", true);
    let api = StaticAnalysisAPI::with_config(configuration);
    let resp = api.create_ai_memory_violation_result(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Create an AI memory violation result returns "Successfully created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.createAiMemoryViolationResult"] = true;
const apiInstance = new v2.StaticAnalysisApi(configuration);

const params: v2.StaticAnalysisApiCreateAiMemoryViolationResultRequest = {
  body: {
    data: {
      attributes: {
        line: 10,
        message: "This is a false positive because the input is sanitized.",
        name: "src/main.py",
        repositoryId: "my-repo",
        rule: "my-ai-ruleset/my-ai-rule",
        sha: "abc123def456789012345678901234567890abcd",
        type: "FP",
      },
      id: "violation-abc",
      type: "ai_memory_violation_result",
    },
  },
};

apiInstance
  .createAiMemoryViolationResult(params)
  .then((data: any) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
